xn::IRMetaData Class Reference
C++ Reference to Application Programmer Interface (API) » Meta-Data Objects (Frame Objects)

`#include <XnCppWrapper.h>`

Inheritance diagram for xn::IRMetaData:
[legend]

## Public Member Functions

| IRMetaData ()
void | InitFrom (const IRMetaData &other)
XnStatus | InitFrom (const IRMetaData &other, XnUInt32 nXRes, XnUInt32 nYRes, const XnIRPixel *pExternalBuffer)
XnStatus | CopyFrom (const IRMetaData &other)
XnStatus | ReAdjust (XnUInt32 nXRes, XnUInt32 nYRes, const XnIRPixel *pExternalBuffer=NULL)
const XnIRPixel * | Data () const
const XnIRPixel *& | Data ()
XnIRPixel * | WritableData ()
const XnIRPixel & | operator[] (XnUInt32 nIndex) const
const XnIRPixel & | operator() (XnUInt32 x, XnUInt32 y) const
const xn::IRMap & | IRMap () const
xn::IRMap & | WritableIRMap ()
const XnIRMetaData * | GetUnderlying () const
XnIRMetaData * | GetUnderlying ()
Public Member Functions inherited from xn::MapMetaData
| MapMetaData (XnPixelFormat format, const XnUInt8 **ppData)
XnUInt32 | XRes () const
XnUInt32 & | XRes ()
XnUInt32 | YRes () const
XnUInt32 & | YRes ()
XnUInt32 | XOffset () const
XnUInt32 & | XOffset ()
XnUInt32 | YOffset () const
XnUInt32 & | YOffset ()
XnUInt32 | FullXRes () const
XnUInt32 & | FullXRes ()
XnUInt32 | FullYRes () const
XnUInt32 & | FullYRes ()
XnUInt32 | FPS () const
XnUInt32 & | FPS ()
XnPixelFormat | PixelFormat () const
const XnMapMetaData * | GetUnderlying () const
XnMapMetaData * | GetUnderlying ()
XnUInt32 | BytesPerPixel () const
XnStatus | AllocateData (XnUInt32 nXRes, XnUInt32 nYRes)
XnStatus | ReAdjust (XnUInt32 nXRes, XnUInt32 nYRes, const XnUInt8 *pExternalBuffer)
Public Member Functions inherited from xn::OutputMetaData
| OutputMetaData (const XnUInt8 **ppData)
virtual | ~OutputMetaData ()
XnUInt64 | Timestamp () const
XnUInt64 & | Timestamp ()
XnUInt32 | FrameID () const
XnUInt32 & | FrameID ()
XnUInt32 | DataSize () const
XnUInt32 & | DataSize ()
XnBool | IsDataNew () const
XnBool & | IsDataNew ()
const XnOutputMetaData * | GetUnderlying () const
XnOutputMetaData * | GetUnderlying ()
const XnUInt8 * | Data () const
const XnUInt8 *& | Data ()
XnUInt8 * | WritableData ()
XnStatus | AllocateData (XnUInt32 nBytes)
void | Free ()
XnStatus | MakeDataWritable ()

## Additional Inherited Members

Protected Member Functions inherited from xn::MapMetaData
XnPixelFormat & | PixelFormatImpl ()
Protected Attributes inherited from xn::OutputMetaData
XnUInt8 * | m_pAllocatedData

## Detailed Description

Purpose: For saving the frame object (data and configuration) from an xn::IRGenerator node. This frame object is a snapshot of the generated infra-red map data and its associated configuration information at a certain point in time. This saved frame object provides fast and easy access to the IRGenerator node's data and configuration information.

## Constructor & Destructor Documentation

## IRMetaData()

xn::IRMetaData::IRMetaData | ( |  | ) |

inline

## Member Function Documentation

## CopyFrom()

XnStatus xn::IRMetaData::CopyFrom | ( | const IRMetaData & | other | ) |

inline

Performs a deep-copy of another metadata object (including duplication of the data buffer)

Parameters

  [in] | other | source object

## Data() [1/2]

const XnIRPixel *& xn::IRMetaData::Data | ( |  | ) |

inline

Returns the IR map.

Remarks

This method returns a pointer to the first IR pixel in the map. The IR map is implemented as a row-major order compact layout of pixels in the map.

The pixel format of the map is XnIRPixel, i.e. 16-bit integer values.

This method is reimplemented from the xn::OutputMetaData class.

## Data() [2/2]

const XnIRPixel * xn::IRMetaData::Data | ( |  | ) | const

inline

Returns the IR map.

Remarks

This method returns a pointer to the first IR pixel in the map. The IR map is implemented as a row-major order compact layout of pixels in the map.

The pixel format of the map is XnIRPixel, i.e. 16-bit integer values.

This method is reimplemented from the xn::OutputMetaData class.

## GetUnderlying() [1/2]

XnIRMetaData * xn::IRMetaData::GetUnderlying | ( |  | ) |

inline

Gets the C object that is wrapped by this object.

## GetUnderlying() [2/2]

const XnIRMetaData * xn::IRMetaData::GetUnderlying | ( |  | ) | const

inline

Gets the C object that is wrapped by this object.

## InitFrom() [1/2]

void xn::IRMetaData::InitFrom | ( | const IRMetaData & | other | ) |

inline

Shallow-Copies an IRMetaData object.

Parameters

  [in] | other | source object.

Remarks
  Note that the data buffer is not copied, and that both object will point to the same buffer.

## InitFrom() [2/2]

XnStatus xn::IRMetaData::InitFrom | ( | const IRMetaData & | other,
|  | XnUInt32 | nXRes,
|  | XnUInt32 | nYRes,
|  | const XnIRPixel * | pExternalBuffer )

inline

Shallow copies another IRMetaData object, and then ReAdjust it.

Parameters

  [in] | other | source object
  [in] | nXRes | requested number of columns in the map
  [in] | nYRes | requested number of rows in the map
  [in] | pExternalBuffer | Optional. An external buffer matching requested resolution. If NULL, A buffer will be allocated.

## IRMap()

const xn::IRMap & xn::IRMetaData::IRMap | ( |  | ) | const

inline

Gets a fast, light object wrapping the IR map. Remarks.

The Map Wrapper classes are light wrappers for generated maps saved as frame objects in metadata. These wrapper classes provide small data-focused objects for simplified data access to frame objects.

## operator()()

const XnIRPixel & xn::IRMetaData::operator() | ( | XnUInt32 | x,
|  | XnUInt32 | y ) const

inline

Gets the value of a single pixel of the frame map by its X and Y coordinates.

Parameters

  [in] | x | X-coordinate of the pixel in the map
  [in] | y | Y-coordinate of the pixel in the map

## operator[]()

const XnIRPixel & xn::IRMetaData::operator[] | ( | XnUInt32 | nIndex | ) | const

inline

Gets the value of a single pixel of the frame map by its index in the array.

Parameters

  [in] | nIndex | The index of the pixel in the buffer.

## ReAdjust()

XnStatus xn::IRMetaData::ReAdjust | ( | XnUInt32 | nXRes,
|  | XnUInt32 | nYRes,
|  | const XnIRPixel * | pExternalBuffer = NULL )

inline

Changes dimensions of the pixel-map.

Parameters

  [in] | nXRes | Number of columns in the map
  [in] | nYRes | Number of rows in the map
  [in] | pExternalBuffer | Optional. An external buffer to be used. If NULL is passed, a buffer will be allocated.

## WritableData()

XnIRPixel * xn::IRMetaData::WritableData | ( |  | ) |

inline

Gets a pointer to the writable buffer (see Frame Objects and Metadata Objects).

## WritableIRMap()

xn::IRMap & xn::IRMetaData::WritableIRMap | ( |  | ) |

inline

Gets a fast, light object wrapping the writable IR map. Remarks.

The Map Wrapper classes are light wrappers for generated maps saved as frame objects in metadata. These wrapper classes provide small data-focused objects for simplified data access to frame objects.

The documentation for this class was generated from the following file:

- XnCppWrapper.h